/*************************************************************************/
/*                                                                       */
/*  Regexx - Regular Expressions C++ solution.                           */
/*                                                                       */
/*  http://projects.nn.com.br/                                           */
/*                                                                       */
/*  Copyright (C) 2000 Gustavo Niemeyer <gustavo@nn.com.br>              */
/*                                                                       */
/*  This library is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU Library General Public          */
/*  License as published by the Free Software Foundation; either         */
/*  version 2 of the License, or (at your option) any later version.     */
/*                                                                       */
/*  This library is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    */
/*  Library General Public License for more details.                     */
/*                                                                       */
/*  You should have received a copy of the GNU Library General Public    */
/*  License along with this library; if not, write to the                */
/*  Free Software Foundation, Inc., 59 Temple Place - Suite 330,         */
/*  Boston, MA  02111-1307, USA.                                         */
/*                                                                       */
/*************************************************************************/

// $Revision: 1.3 $
// $Date: 2000/04/05 00:29:22 $

#include "split.hh"

vector<string>
regexx::split(const string& _where, const string& _str)
{
  vector<string> v;
  string::size_type lastpos = 0;
  string::size_type pos = _str.find(_where);
  while(pos != string::npos) {
    v.push_back(_str.substr(lastpos,pos-lastpos));
    lastpos = pos+_where.length();
    pos = _str.find(_where,lastpos);
  }
  v.push_back(_str.substr(lastpos));
  return v;
}

vector<string>
regexx::splitex(const string& _regex, const string& _str)
{
  vector<string> v;
  Regexx rxx;
  rxx.expr(_regex);
  rxx.str(_str);
  v.reserve(rxx.exec());
  vector<RegexxMatch>::const_iterator i;
  string::size_type lastpos = 0;
  for(i = rxx.match.begin(); i != rxx.match.end(); i++) {
    v.push_back(_str.substr(lastpos,i->start()-lastpos));
    lastpos = i->start()+i->length();
  }
  v.push_back(_str.substr(lastpos,i->start()));
  return v;
}
